/* send_sysrq - send remote sysrq over udp */

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <time.h>

#include "rsysrq.h"

#define	PORT	9

unsigned char rnd_gen( void )
{
	return( (unsigned char)(((long long)random()*(long long)256)/(long long)RAND_MAX) );
}

int send_udp( unsigned int ip, int port, char c, char *pass )
{ int sock;
  struct sockaddr_in addr;
  struct rsysrq_s rq;
  time_t t;
  int len;
//  int i;

	t=time(NULL);
	srandom(t+(getpid()<<16));
	rsysrq_create(&rq,c,pass,rnd_gen,(my_time_t)t);
	len= sizeof(rq);

/*
	for(i=0;i<len;i++)
		printf("0x%02x ",((unsigned char*)(&rq))[i]&0x00ff);
	printf("\n");

	c=rsysrq_extract(&rq,pass,(my_time_t)t,0);
	if( c==0 )
		printf("error\n");
	else
		printf("cmd: %c\n",c);
*/

	sock=socket(PF_INET,SOCK_DGRAM,0);
	addr.sin_family = AF_INET;
	addr.sin_addr.s_addr= ip;
	addr.sin_port=htons(port);
	if( sendto(sock,&rq,len,0,(struct sockaddr*)&addr,sizeof(struct sockaddr_in))<0 )
	{	close(sock);
		return(-1);
	}
	close(sock);
	return(0);
}

#define	iaddr_c2i(c)	(*(int *)(c))

int net_name2ip(char *name, unsigned int *ip)
{ struct hostent *he;
	if(!name[0])
	{	*ip=(unsigned int)inet_addr ("127.0.0.1");
		return(1);
	}
	if( (*ip=(unsigned int)inet_addr(name))!=(unsigned int)(-1) )
		return(1);
	if( (he=gethostbyname(name))==NULL )
		return(0);
	*ip=(unsigned int)iaddr_c2i(he->h_addr);
	return(1);
}

int main( int argc, char *argv[] )
{ char *addr=NULL;
  char *cmds=NULL;
  char *pass;
  char *pass2;
  int port=PORT;
  int a;
  unsigned int ip;
  int r;

	for(a=1;a<argc && argv[a][0]=='-';a++)
	{
		if( !strcmp(argv[a],"-p") && a+1<argc )
		{	if( (port=atoi(argv[++a]))<=0 )
				goto usage;
		}
		else
		{
usage:			printf("usage: %s [-p <port>] <host> <cmds>\n",argv[0]);
			return(0);
		}
	}
	if( argc-a!=2 )
		goto usage;

	addr=argv[a++];
	cmds=argv[a];

	net_name2ip(addr,&ip);

	for(;;)
	{
		pass2=strdup(getpass("Enter password: "));
		pass=getpass("ReEnter password: ");

		if( !strcmp(pass2,pass) )
			break;
		printf("Don't match!\n\n");
		free(pass2);
	}
	free(pass2);

	while( *cmds )
	{
		if( *cmds=='-' )
		{
			sleep(2);
		}
		else
		{
			r=send_udp(ip,port,*cmds,pass);
			sleep(1);
			r=send_udp(ip,port,*cmds,pass);
			sleep(1);
		}
		cmds++;
	}
	return(r);
}

